package me.totalfreedom.discord.command;

import discord4j.core.event.domain.interaction.ChatInputInteractionEvent;
import discord4j.core.spec.EmbedCreateSpec;
import discord4j.rest.util.Color;
import me.totalfreedom.discord.handling.SlashCommand;
import reactor.core.publisher.Mono;

import java.time.Instant;

public class HelpCommand implements SlashCommand
{
    @Override
    public String getName()
    {
        return "help";
    }

    @Override
    public Mono<Void> handle(ChatInputInteractionEvent event)
    {
        EmbedCreateSpec spec = EmbedCreateSpec.builder()
                .color(Color.GREEN)
                .title("Help Command")
                .addField("Commands", "This is a list of all commands", false)
                .addField("\u200B", "\u200B", false)
                .addField("help", "Displays the help command. (This command.)", true)
                .addField("list", "Displays a list of all online players.", true)
                .addField("tps", "Displays the server's TPS.", true)
                .timestamp(Instant.now())
                .build();

        return event.reply()
                .withEmbeds(spec);
    }
}
