package me.totalfreedom.discord.command;

import discord4j.core.event.domain.interaction.ChatInputInteractionEvent;
import discord4j.core.spec.EmbedCreateSpec;
import discord4j.rest.util.Color;
import me.totalfreedom.discord.handling.SlashCommand;
import me.totalfreedom.totalfreedommod.config.ConfigEntry;
import org.bukkit.Bukkit;
import org.bukkit.entity.HumanEntity;
import reactor.core.publisher.Mono;

import java.util.Iterator;
import java.util.List;

public class ListCommand implements SlashCommand
{

    @Override
    public String getName()
    {
        return "list";
    }

    @Override
    public Mono<Void> handle(ChatInputInteractionEvent event)
    {
        List<String> playerNames = Bukkit.getOnlinePlayers()
                .stream()
                .map(HumanEntity::getName)
                .toList();

        StringBuilder sb = new StringBuilder();
        Iterator<String> iterator = playerNames.iterator();
        while (iterator.hasNext()) {
            sb.append(iterator.next());
            if (iterator.hasNext()) {
                sb.append(", \n");
            }
        }

        String empty = "\u200B";

        EmbedCreateSpec spec = EmbedCreateSpec.builder()
                .title("Player List - " + ConfigEntry.SERVER_NAME.getString())
                .color(Color.BISMARK)
                .addField("Online Players", String.join(", ", playerNames), false)
                .addField(empty, "Currently Online: " + playerNames.size(), false)
                .addField(empty, empty, false)
                .addField("Players: ", sb.toString(), true)
                .build();

        return event.reply()
                .withEmbeds(spec)
                .withEphemeral(true)
                .withContent(sb.toString());
    }
}
